#include "Components/MujocoBodyComponent.h"
#include "Misc/UniqueNamedComponent.h"

UMujocoBodyComponent::UMujocoBodyComponent()
{
	PrimaryComponentTick.bCanEverTick = false;
}

#if WITH_EDITORONLY_DATA
void UMujocoBodyComponent::OnComponentCreated()
{
	Super::OnComponentCreated();

	if (GEngine && GetWorld())
	{
		FString UniqueName = GenerateUniqueName(GetWorld(), this, GetName());
		Rename(*UniqueName);
	}
}

void UMujocoBodyComponent::PostEditChangeProperty(FPropertyChangedEvent& PropertyChangedEvent)
{
	Super::PostEditChangeProperty(PropertyChangedEvent);

	if (GEngine && GetWorld())
	{
		FString UniqueName = GenerateUniqueName(GetWorld(), this, GetName());
		Rename(*UniqueName);
	}
}
#endif
