#include "Components/MujocoSiteComponent.h"
#include "Components/MujocoBodyComponent.h"

UMujocoSiteComponent::UMujocoSiteComponent()
{
    PrimaryComponentTick.bCanEverTick = false;
}

#if WITH_EDITORONLY_DATA
void UMujocoSiteComponent::OnComponentCreated() 
{
	Super::OnComponentCreated();
	if (GEngine && GetWorld())
	{
		if (UMujocoBodyComponent* ParentBody = Cast<UMujocoBodyComponent>(GetAttachParent()))
		{
			FString BodyName = ParentBody->GetName();
			FString UniqueName = GenerateUniqueName(GetWorld(), this, BodyName + TEXT("_Site"));
			Rename(*UniqueName);
		}
		else
		{
			FString UniqueName = GenerateUniqueName(GetWorld(), this, GetName());
			Rename(*UniqueName);
		}
	}
}

void UMujocoSiteComponent::PostEditChangeProperty(FPropertyChangedEvent& PropertyChangedEvent) 
{
	Super::PostEditChangeProperty(PropertyChangedEvent);
	if (GEngine && GetWorld())
	{
		FString UniqueName = GenerateUniqueName(GetWorld(), this, GetName());
		Rename(*UniqueName);
	}
}
#endif
