#include "LuckyMujoco.h"
#include "Misc/MessageDialog.h"
#include "Modules/ModuleManager.h"
#include "Interfaces/IPluginManager.h"
#include "Misc/Paths.h"
#include "HAL/PlatformProcess.h"

DEFINE_LOG_CATEGORY(LogMujoco);

#define LOCTEXT_NAMESPACE "FLuckyMujocoModule"

void FLuckyMujocoModule::StartupModule()
{


#if PLATFORM_WINDOWS
	FString Library = FPaths::Combine(FPaths::ProjectDir(), TEXT("Binaries/Win64/mujoco.dll"));
	MujocoHandle = !Library.IsEmpty() ? FPlatformProcess::GetDllHandle(*Library) : nullptr;
	
	if (MujocoHandle == nullptr)
	{
		FMessageDialog::Open(EAppMsgType::Ok, LOCTEXT("MujocoLibraryError", "Failed to load Mujoco library. Please make sure that Mujoco is installed and the library is in the correct path."));
	}
#endif
}

void FLuckyMujocoModule::ShutdownModule()
{
	if (MujocoHandle != nullptr)
	{
		FPlatformProcess::FreeDllHandle(MujocoHandle);
		MujocoHandle = nullptr;
	}
}

#undef LOCTEXT_NAMESPACE

IMPLEMENT_MODULE(FLuckyMujocoModule, LuckyMujoco)
