#pragma once

#include "CoreMinimal.h"
#include "Enums/MujocoEnums.h"
#include "Structs/MujocoActuator.h"
#include "Misc/UniqueNamedComponent.h"
#include "MujocoActuatorComponent.generated.h"

UCLASS(Blueprintable, ClassGroup = (Rendering, Common), hidecategories = (Object, Activation, "Components|Activation"), ShowCategories = (Mobility), editinlinenew, meta = (BlueprintSpawnableComponent))
class LUCKYMUJOCO_API UMujocoActuatorComponent : public UActorComponent, public TUniqueNamedComponent
{
	GENERATED_BODY()

public:
	UMujocoActuatorComponent();

	UPROPERTY(Transient, VisibleAnywhere, Category = "Mujoco")
	int32 MujocoID = -1;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "Mujoco")
	FMujocoActuatorV2 Actuator;

#if WITH_EDITORONLY_DATA
	virtual void OnComponentCreated() override;
	virtual void PostEditChangeProperty(FPropertyChangedEvent& PropertyChangedEvent) override;
#endif
};
