#pragma once

#include "CoreMinimal.h"
#include "Enums/MujocoEnums.h"
#include "Structs/MujocoEquality.h"
#include "Misc/UniqueNamedComponent.h"
#include "MujocoEqualityComponent.generated.h"

UCLASS(Blueprintable, ClassGroup = (Rendering, Common), hidecategories = (Object, Activation, "Components|Activation"), ShowCategories = (Mobility), editinlinenew, meta = (BlueprintSpawnableComponent))
class LUCKYMUJOCO_API UMujocoEqualityComponent : public UActorComponent, public TUniqueNamedComponent
{
	GENERATED_BODY()

public:
	UMujocoEqualityComponent();

	UPROPERTY(Transient, VisibleAnywhere, Category = "Mujoco")
	int32 MujocoID = -1;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "Mujoco")
	FMujocoEquality Equality;

#if WITH_EDITORONLY_DATA
	virtual void OnComponentCreated() override;
	virtual void PostEditChangeProperty(FPropertyChangedEvent& PropertyChangedEvent) override;
#endif
};
