#pragma once

#include "CoreMinimal.h"
#include "Components/StaticMeshComponent.h"
#include "Enums/MujocoEnums.h"
#include "Structs/MujocoGeom.h"
#include "Misc/UniqueNamedComponent.h"
#include "Misc/MujocoStaticMesh.h"
#include "MujocoGeomComponent.generated.h"

UCLASS(Blueprintable, ClassGroup = (Rendering, Common), hidecategories = (Object, Activation, "Components|Activation"), ShowCategories = (Mobility), editinlinenew, meta = (BlueprintSpawnableComponent))
class LUCKYMUJOCO_API UMujocoGeomComponent : public UStaticMeshComponent, public TUniqueNamedComponent
{
	GENERATED_BODY()

public:
	UMujocoGeomComponent();

	UPROPERTY(Transient, VisibleAnywhere, Category = "Mujoco")
	int32 MujocoID = -1;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "Mujoco")
	FMujocoGeom Geom;

	UPROPERTY(EditAnywhere, meta = (DisplayName = "Mujoco Mesh"), Category = "StaticMesh")
	TObjectPtr<UStaticMesh> MujocoStaticMesh;

#if WITH_EDITORONLY_DATA
	virtual void OnComponentCreated() override;
	virtual void PostEditChangeProperty(FPropertyChangedEvent& PropertyChangedEvent) override;

	virtual void PostInitProperties() override;	
	virtual void PreStaticMeshCompilation() override;
	virtual void PostStaticMeshCompilation() override;
	virtual void OnRegister() override;
#endif
};
