#pragma once

#include "CoreMinimal.h"
#include "Enums/MujocoEnums.h"
#include "Components/SceneComponent.h"
#include "Structs/MujocoSite.h"
#include "Misc/UniqueNamedComponent.h"
#include "MujocoSiteComponent.generated.h"

UCLASS(Blueprintable, ClassGroup = (Rendering, Common), hidecategories = (Object, Activation, "Components|Activation"), ShowCategories = (Mobility), editinlinenew, meta = (BlueprintSpawnableComponent))
class LUCKYMUJOCO_API UMujocoSiteComponent : public USceneComponent, public TUniqueNamedComponent
{	
	GENERATED_BODY()

public:
	UMujocoSiteComponent();

	UPROPERTY(Transient, VisibleAnywhere, Category = "Mujoco")
	int32 MujocoID = -1;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "Mujoco")
	FMujocoSite Site;

#if WITH_EDITORONLY_DATA
	virtual void OnComponentCreated() override;
	virtual void PostEditChangeProperty(FPropertyChangedEvent& PropertyChangedEvent) override;
#endif
};
