#pragma once

#include "CoreMinimal.h"
#include "Engine/StaticMesh.h"
#include "MujocoStaticMesh.generated.h"

UCLASS(BlueprintType)
class LUCKYMUJOCO_API UMujocoStaticMesh : public UStaticMesh
{
	GENERATED_BODY()
public:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "Mujoco Mesh Data")
	float ObjScale = 0.01f;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "Mujoco Mesh Data")
	int32 LodIndex = 0;
	
	UPROPERTY()
	FString ObjFileData;

#if WITH_EDITORONLY_DATA
	virtual void PostEditChangeProperty(FPropertyChangedEvent& PropertyChangedEvent) override;
	void RefreshObjFileData();
#endif	
};
