#pragma once

#include "CoreMinimal.h"
#include "Enums/MujocoEnums.h"
#include "MujocoInertial.generated.h"

USTRUCT(BlueprintType)
struct FMujocoInertial
{
	GENERATED_BODY()

	/** Position of the inertial frame. */
	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "Mujoco | Inertial", meta = (Attribute = "pos"))
	TOptional<FVector> Pos;

	/** Mass of the body. */
	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "Mujoco | Inertial", meta = (Attribute = "mass"))
	TOptional<double> Mass;

	/** Diagonal inertia matrix, expressing the body inertia relative to the inertial frame. */
	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "Mujoco | Inertial", meta = (Attribute = "diaginertia"))
	TOptional<FVector> DiagInertia;

	/** Full inertia matrix M. */
	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "Mujoco | Inertial", meta = (Attribute = "fullinertia"))
	TOptional<FMujocoGear> FullInertia;
};