#pragma once

#include "IDetailCustomization.h"
#include "Internationalization/Text.h"
#include "Templates/SharedPointer.h"

class FMujocoPropertyCustomization : public IPropertyTypeCustomization
{
	TArray<TSharedPtr<FName>> BodyOptions;
	TArray<TSharedPtr<FName>> SiteOptions;
	TArray<TSharedPtr<FName>> JointOptions;
	TArray<TSharedPtr<FName>> GeomOptions;
	TArray<TSharedPtr<FName>> TendonOptions;
	TArray<TSharedPtr<FName>> FlexOptions;

	TSharedRef<SWidget> MakeNameComboBox(const TSharedPtr<IPropertyHandle>& PropertyHandle, TArray<TSharedPtr<FName>>& Options);

public:
	static TSharedRef<IPropertyTypeCustomization> MakeInstance();

	virtual void CustomizeHeader(TSharedRef<IPropertyHandle> PropertyHandle, FDetailWidgetRow& HeaderRow, IPropertyTypeCustomizationUtils& CustomizationUtils) override;
	virtual void CustomizeChildren(TSharedRef<IPropertyHandle> StructPropertyHandle, IDetailChildrenBuilder& StructBuilder, IPropertyTypeCustomizationUtils& StructCustomizationUtils) override;
};